# Running on modern android

So there are a few things on modern android versions, that kind of get in the way of using the PSM app

- Since android 6, you can no longer just remount /system/ as read-write, (even as root)
this makes it hard to install the "PlayStation Certificates".

- Since android 7, android_id is unique *per-app* instead of *per-device*,
this means that when generating the signin cache,
you have to find the android_id used *by psm*.

- Since android 10, it's no longer possible for apps to just write to ``/android/data/com.playstation.psstore/files/psm``
which is where the PSM Application *stores* PSM games, however- it is still possible to write there using MTP or ADB.
BUT the file permissions get messed up when you do this.

- Since android 14, android refuses to install any application targeting SDK <23.
this includes PSM, and also. NoPsmDrm because it's trying to be compatible with old android also.

There are some workarounds for all of these.
using PSM on newer versions can be a bit annoying.


To get the app working on modern android versions; you need to:

First, install the PlayStation Certificates *systemlessly* via a Magisk Module.
i have made one to do this and it can be found here; https://silica.codes/Li/MagiskCertify (Android 6+)

After that, you can install the PlayStation Mobile app, *and* the NoPsmDrm app,
if your on android >14, this *has* to be done via ADB with USB Debugging 
because that gives you access to the `--bypass-low-target-sdk-block` argument

(You will get a Play Protect warning for both of these)

```adb install --bypass-low-target-sdk-block PSM.apk```

```adb install --bypass-low-target-sdk-block NoPsmDrm-Android.apk```

Once installed, you need to tap on both apps and goto permissions and grant *everything* 
older android versions (prior to 6.0) handled permissions differnetly and expected to have
everything granted at install time .. so make sure you do that!

Workaround for android_id on Android 7+, once done that open NoPsmDrm, and click install. 
it will then tell you to open the PSM app, do that, 
wait for the 'failed to connect' message, and then just close the PSM app. 
return to NoPsmDrm and click install once more and *that time* it should work.

Now you can just copy PSM games to ``/sdcard/android/data/com.playstation.psstore/files/psm``
however as of android 10, you can *only* do this via ADB *or* via the USB connection to your phone

if after doing this you do not see the games pop up in the PSM app try the "Fix permissions" button in NoPsmDrm. 
