package com.psmreborn.nops1drm;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;

import com.psmreborn.shared.Logger;
import com.psmreborn.shared.Root;

public class LicenseCheckActivity extends Activity {
    private static final int RESPONSE_CODE = 19941203;

    public void respond(byte[] response, int resp){
        Intent resIntent = new Intent();
        resIntent.putExtra("result_data", response);
        this.setResult(resp, resIntent);
        this.finish();
    }
    @Override
    protected void onActivityResult(int res, int res_code, Intent intent) {
        if(res == RESPONSE_CODE) {
            byte[] result_data = intent.getByteArrayExtra("result_data");
            Logger.logBytes("RESULT_DATA", result_data);
            Logger.logText( "RES", String.valueOf(res_code));
            respond(result_data, res_code);
        }
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);


        // Read intent from ps1 game
        String entitlement_id = this.getIntent().getStringExtra("entitlement_id");
        byte[] input_data = this.getIntent().getByteArrayExtra("input_data");

        Logger.logText("ENTITLEMENT_ID", entitlement_id);
        Logger.logBytes("INPUT_DATA", input_data);

        // Generate ticket and put it into com.playstation.psstore databases.

        Handler handler = new Handler(this.getMainLooper());
        new Thread(()->{
            try {
                if(Root.init(this)){
                    PsmStartupCache.addEntitlement(this, entitlement_id);

                    handler.post(() ->{
                        // Forward intent to psm.apk
                        Intent intent = new Intent("com.playstation.android.intent.action.CHECK_ENTITLEMENT");
                        intent.putExtra("entitlement_id", entitlement_id);
                        intent.putExtra("input_data", input_data);
                        intent.setPackage("com.playstation.psstore");

                        startActivityForResult(intent, RESPONSE_CODE);
                    });
                }
                else{
                    handler.post(() -> {
                        respond(new byte[]{}, 0);
                    });
                }

            } catch (Exception e) {
                Log.e("LicenseCheckerActivity", e.toString());
                handler.post(() -> {
                    respond(new byte[]{}, 0);
                });
            }
        }).start();



    }
}
