package com.psmreborn.nopsmdrm;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;

import com.psmreborn.shared.Helper;

import java.io.File;
import java.io.IOException;

public class DumpAllRifs {
    public static void setDumpAllFlagAndStartPsm(Activity ctx) {
        ProgressDialog dialog = new ProgressDialog(ctx);
        dialog.setTitle("Starting PSM ...");
        dialog.setMessage("Please Wait ...");
        dialog.setIndeterminate(true);
        dialog.setCancelable(false);
        dialog.show();

        new Thread(() -> {
            Handler handler = new Handler(ctx.getMainLooper());
            File psmFolder = new File(Environment.getExternalStorageDirectory(), "psm");
            File psmDumpAllFlagFile = new File(psmFolder, "dump_all");
            File psmAndroidFolder = new File(new File(new File(new File(new File(Environment.getExternalStorageDirectory(), "Android"), "data"), "com.playstation.psstore"), "files"), "psm");

            // stop psm
            Helper.killPsm(ctx);

            try {
                psmDumpAllFlagFile.createNewFile();
            } catch (IOException e) {
                return;
            }

            // get a games title id..
            String titleId = "";
            String[] allGames = psmAndroidFolder.list();
            for(String chkTitleId : allGames) {
                File appInfoFile = new File(new File(new File(psmAndroidFolder, chkTitleId), "Application"), "app.info");
                if(appInfoFile.exists()){
                    titleId = chkTitleId;
                }
            }

            if(titleId.equals("")){
                return;
            }

            Log.d("DUMPALLRIFS", "Using TitleID: "+titleId);

            WifiManager wifiManager = (WifiManager) ctx.getApplicationContext().getSystemService(Context.WIFI_SERVICE);
            if(wifiManager != null){
                Intent intent = new Intent("com.playstation.psm.intent.action.START_CONTENT");
                intent.putExtra("titleId", titleId);
                intent.setData(Uri.parse("psgmpsm:play?titleId="+titleId));

                handler.post(() -> {
                    // disable wifi
                    wifiManager.setWifiEnabled(false);

                    // start psm ...
                    ctx.startActivity(intent);

                    dialog.dismiss();
                });
            }
            else{
                return;
            }
        }).start();
    }
}
