package com.psmreborn.shared;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.os.Handler;

import com.psmreborn.nopsmdrm.Startup;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.io.BufferedInputStream;
import java.io.InputStream;
import java.io.OutputStream;

public class Downloader {
    static boolean wasError = false;
    static String errorMsg = "";

    private static void showErrorMessage(Activity ctx){
        new AlertDialog.Builder(ctx)
                .setTitle("Error Occurred.")
                .setMessage(errorMsg)
                .setCancelable(false)
                .setPositiveButton("Ok",null).show();
    }
    private static void showInstallSuccessMsg(Activity ctx, String filename){
        new AlertDialog.Builder((Activity)ctx)
                .setTitle("Install complete!")
                .setMessage("Sucessfully installed: "+ filename)
                .setCancelable(false)
                .setPositiveButton("Ok", null).show();
    }
    private static void showDownloadSuccessMsg(Activity ctx, String filename){
        new AlertDialog.Builder((Activity)ctx)
                .setTitle("Download complete!")
                .setMessage("Sucessfully downloaded: "+ filename)
                .setCancelable(false)
                .setPositiveButton("Ok",null).show();
    }


    private static void download(String uri, String dstFile) throws IOException {

        URL url = new URL(uri);
        URLConnection connection = url.openConnection();
        connection.connect();

        InputStream input = new BufferedInputStream(url.openStream(), 8192);
        OutputStream output = new FileOutputStream(dstFile);

        Files.copyTo(input, output);
        output.close();
        input.close();
    }
    public static void downloadAndInstall(Activity ctx, String url){
        ProgressDialog dialog = new ProgressDialog(ctx);
        final String filename = new File(url).getName();

        final String saveLocation = new File(ctx.getCacheDir(), filename).getAbsolutePath();

        dialog.setTitle("Downloading "+filename+"...");
        dialog.setMessage("Please Wait ...");
        dialog.setIndeterminate(true);
        dialog.setCancelable(false);
        dialog.show();

        new Thread(() -> {
            Handler handler = new Handler(ctx.getMainLooper());

            Helper.killPsm(ctx);
            try {
                download(url, saveLocation);
                handler.post(() -> {dialog.setTitle("Installing "+filename+"...");});
                Root.installRoot(saveLocation);
            } catch (Exception e) {
                wasError = true;
                errorMsg = e.toString();
            }

            handler.post(() -> {
                dialog.dismiss();
                Startup.updateNames(ctx);

                if(wasError){
                    showErrorMessage(ctx);
                }
                else {
                    showInstallSuccessMsg(ctx, filename);
                }
            });

        }).start();
    }
    public static void downloadFile(Activity ctx, String url, String saveLocation) {
        ProgressDialog dialog = new ProgressDialog(ctx);
        final String filename = new File(url).getName();

        dialog.setTitle("Downloading "+filename+"...");
        dialog.setMessage("Please Wait ...");
        dialog.setIndeterminate(true);
        dialog.setCancelable(false);
        dialog.show();

        new Thread(() -> {
            Handler handler = new Handler(ctx.getMainLooper());

            Helper.killPsm(ctx);
            try {
                download(url, saveLocation);
            } catch (IOException e) {
                wasError = true;
                errorMsg = e.toString();
            }

            handler.post(() -> {
                dialog.dismiss();
                Startup.updateNames(ctx);

                if(wasError){
                    showErrorMessage(ctx);
                }
                else {
                    showDownloadSuccessMsg(ctx, filename);
                }
            });

        }).start();
    }


}
