package com.psmreborn.shared;

import android.content.Context;
import android.util.Log;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class Files {
    public static void unpackResource(Context ctx, int resourceId, File outputFile) throws IOException {
        Log.i("ROOT", "Unpacking resource to : " + outputFile);
        InputStream resourceStream = ctx.getResources().openRawResource(resourceId);

        FileOutputStream fs = new FileOutputStream(outputFile, false);
        copyTo(resourceStream, fs);
        fs.close();

        resourceStream.close();
    }
    public static void writeTxtFile(String txtFile, String txt) throws IOException {
        Log.i("ROOT", "Writing: " + txtFile);
        FileWriter txtStream = new FileWriter(txtFile);
        txtStream.write(txt);
        txtStream.close();
    }

    public static void copyTo(InputStream inpStream, OutputStream outStream) throws IOException {
        byte[] buffer = new byte[8192];
        int totalRead;

        while(true){
            totalRead = inpStream.read(buffer, 0, buffer.length);
            if(totalRead == -1)
                break;
            outStream.write(buffer, 0, totalRead);
        }

        outStream.flush();
    }
}
